bool GaborWaveletTexture::DllTraceDIB(short* lpDIBBits, long lWidth, long lHeight)
{
	//This C++ source code is to find the boundary of tumor on the segmanted tumor image. The tumor image is manually segmented by radiologist.
	short*	lpSrc;
	
	short*	lpDst;
	
	short*	lpNewDIBBits;
	HLOCAL	hNewDIBBits;

	long lLineBytes;
	
	long i;
	long j;

	short pixel;

	bool bFindStartPoint;

	bool bFindPoint;

	DllSeed StartPoint,CurrentPoint;

	int Direction[8][2]={{-1,1},{0,1},{1,1},{1,0},{1,-1},{0,-1},{-1,-1},{-1,0}};
	int BeginDirect;

	lLineBytes = lWidth ;

	hNewDIBBits = LocalAlloc(LHND, lLineBytes * lHeight*2);

	if (hNewDIBBits == NULL)
	{
		return FALSE;
	}
	
	lpNewDIBBits = (short * )LocalLock(hNewDIBBits);
	lpDst = (short *)lpNewDIBBits;
	memset(lpDst, (short)0, lLineBytes * lHeight*2);

    bFindStartPoint = false;
    for (j = lHeight;j > 0 && !bFindStartPoint;j--)
    {
        for(i = lWidth;i > 0 && !bFindStartPoint;i--)
        {		
            lpSrc = (short *)lpDIBBits + lLineBytes * j + i;

            pixel = (short)*lpSrc;

            if(pixel == 4096)
            {
                bFindStartPoint = true;

                StartPoint.Height = j;
                StartPoint.Width = i;	                	
                lpDst = (short *)lpNewDIBBits + lLineBytes * j + i;	
                *lpDst = (short)0;
            }		
        }
    }


	for (j = 0;j < lHeight ;j++)
	{
		for(i = 0;i < lWidth ;i++)
		{
			if( i==0 || j==0 || i==lWidth-1 || j==lHeight-1 )                         
			{
				*((short *)lpDIBBits + lLineBytes * j + i)=0;
			}

		}
	}

	BeginDirect = 0;
	bFindStartPoint = false;
	CurrentPoint.Height = StartPoint.Height;
	CurrentPoint.Width = StartPoint.Width;

	while(!bFindStartPoint)
	{
		bFindPoint = false;
		while(!bFindPoint )
		{
			lpSrc = (short *)lpDIBBits + lLineBytes * ( CurrentPoint.Height + Direction[BeginDirect][1])
				+ (CurrentPoint.Width + Direction[BeginDirect][0]);
			pixel = *lpSrc;
			if(pixel == 4096)
			{
				bFindPoint = true;
				CurrentPoint.Height = CurrentPoint.Height + Direction[BeginDirect][1];
				CurrentPoint.Width = CurrentPoint.Width + Direction[BeginDirect][0];
				
				if(CurrentPoint.Height == StartPoint.Height && CurrentPoint.Width == StartPoint.Width)
				{
					bFindStartPoint = true;
				}
				lpDst = (short *)lpNewDIBBits + lLineBytes * CurrentPoint.Height + CurrentPoint.Width;
				*lpDst = (short)4096;
				BeginDirect--;
				if(BeginDirect == -1)
					BeginDirect = 7;
				BeginDirect--;
				if(BeginDirect == -1)
					BeginDirect = 7;
			}
			else
			{
				BeginDirect++;
				if(BeginDirect == 8)
					BeginDirect = 0;

			}

		}
	}
	memcpy(lpDIBBits, lpNewDIBBits, lWidth * lHeight*2);
	LocalUnlock(hNewDIBBits);
	LocalFree(hNewDIBBits);
	return TRUE;
}}
 