RunLengthClass GaborWaveletTexture::RunLengthFeatureComputationinDWT(short * pNorData,int NormalizationMax,int nHeight_H,int nWidth_H)
{
	/*
	This  C++ source code represents how to calculate the key feature: "Long-Run-High-Gray-Level Emphasis of Run Length".
	Four images were obtained from one original image by wavelet transformation (LL, LH, HL, HH), and Run-Length features are calculated on the four images.
	pNorData presents the image after wavelet transformation. NormalizationMax represents the maximum value used for image normalization. nHeight_H and nWidth_H denote the height and width of the image.
	*/
	int NormalizationLimit =  NormalizationMax;
	RunLengthClass RunLengthFeature = {0};
	int Height = nHeight_H;
	int Width = nWidth_H;
	short * pData = new short[Height*Width];
	memset(pData,0,sizeof(short)*Height*Width);
	memcpy(pData,pNorData,sizeof(short)*Height*Width);
	short * RunLengthMatrix = new short[(NormalizationLimit+1)*Width];
	memset(RunLengthMatrix,0,sizeof(short)*(NormalizationLimit+1)*Width);

	for(int Direction = 0;Direction < 4;Direction++)
	{
		int sum = 0;
		int TumorNumberSum = 0;
		bool * NonProcess = new bool [NormalizationLimit+1];
		memset(NonProcess,0,sizeof(bool)*(NormalizationLimit+1));
		double RunLengthSum = 0.0;//

		double LongRunHighGrayLevelEmphasis = 0.0;//Long-Run-High-Gray-Level Emphasis of Run Length

		short ** RunLengthFeatureArray = new short * [NormalizationLimit+1];
		int RunLengthNumberMax = 0;
		for(int i = 0;i <= NormalizationLimit;i++)
		{
			RunLengthFeatureArray[i] = new short [Width];
			memset(RunLengthFeatureArray[i],0,sizeof(short)*Width);
		}
		if(Direction == 0)
		{
			for(int i = 0;i < Height;i++)
			{
				for(int j = 0;j < Width;j++)
				{
					if(pData[i*Width+j] != 0)
					{
						int temp = pData[i*Width+j];
						if(NonProcess[temp] == false)
						{
							for(int ii = 0;ii < Height;ii++)
							{
								for(int jj = 0;jj < Width;jj++)
								{
									if(pData[ii*Width+jj] == pData[i*Width+j])//direction of 0
									{
										sum++;
									}
									else
									{
										if (sum > RunLengthNumberMax)
											RunLengthNumberMax = sum;
										if (sum > 0)
											RunLengthFeatureArray[temp][sum]++;
										sum = 0;
									}
								}
							}
						}
						NonProcess[temp] = true;
						TumorNumberSum++;
					}
				}
			}
		}
		if(Direction == 1)
		{
			for(int i = 0;i < Height;i++)
			{
				for(int j = 0;j < Width;j++)
				{
					if(pData[i*Width+j] != 0)
					{
						int temp = pData[i*Width+j];
						if(NonProcess[temp] == false)
						{
							for(int ii = 0;ii < Height;ii++)
							{
								for(int jj = 0;jj < Width;jj++)
								{
									if(pData[jj*Width+ii] == pData[i*Width+j])////direction of 90
									{
										sum++;
									}
									else
									{
										if (sum > RunLengthNumberMax)
											RunLengthNumberMax = sum;
										if (sum > 0)
											RunLengthFeatureArray[temp][sum]++;
										sum = 0;
									}
								}
							}
						}
						NonProcess[temp] = true;
						TumorNumberSum++;
					}
				}
			}
		}
		if(Direction == 2)
		{
			for(int i = 0;i < Height;i++)
			{
				for(int j = 0;j < Width;j++)
				{
					if(pData[i*Width+j] != 0)
					{
						int temp = pData[i*Width+j];
						if(NonProcess[temp] == false)
						{
							for(int ii = 0;ii < Width*2;ii++)
							{
								for(int jj = 0;jj <= ii;jj++)
								{
									if(((ii-jj) < Width)&&(jj < Width))
									{
										if(pData[(ii-jj)*Width+jj] == pData[i*Width+j])////direction of 45
										{
											sum++;
										}
										else
										{
											if (sum > RunLengthNumberMax)
												RunLengthNumberMax = sum;
											if (sum > 0)
												RunLengthFeatureArray[temp][sum]++;
											sum = 0;
										}
									}
								}
							}
						}
						NonProcess[temp] = true;
						TumorNumberSum++;
					}
				}
			}
		}
		if(Direction == 3)
		{
			for(int i = 0;i < Height;i++)
			{
				for(int j = 0;j < Width;j++)
				{
					if(pData[i*Width+j] != 0)
					{
						int temp = pData[i*Width+j];
						if(NonProcess[temp] == false)
						{
							for(int ii = 0;ii < Width*2;ii++)
							{
								for(int jj = 0;jj <= ii;jj++)
								{
									if(((ii-jj) < Width)&&((Width-jj) >= 0))
									{
										if(pData[(ii-jj)*Width+Width-jj] == pData[i*Width+j])////direction of 135
										{
											sum++;
										}
										else
										{
											if (sum > RunLengthNumberMax)
												RunLengthNumberMax = sum;
											if (sum > 0)
												RunLengthFeatureArray[temp][sum]++;
											sum = 0;
										}
									}
								}
							}
						}
						NonProcess[temp] = true;
						TumorNumberSum++;
					}
				}
			}
		}
		for (int i = 1; i <= NormalizationLimit; i++)
		{
			double GrayLevelNonUniformityr = 0.0;
			double Meani = 0.0;
			for (int j = 1; j <= RunLengthNumberMax; j++)
			{
				RunLengthSum = RunLengthSum + RunLengthFeatureArray[i][j];
				LongRunHighGrayLevelEmphasis = LongRunHighGrayLevelEmphasis + (double)RunLengthFeatureArray[i][j] * i*i*j*j;
			}
		}
		RunLengthFeature.LongRunHighGrayLevelEmphasis = RunLengthFeature.LongRunHighGrayLevelEmphasis + LongRunHighGrayLevelEmphasis/RunLengthSum;//Accumulation of Long-Run-High-Gray-Level Emphasis of Run Length 
	}
	RunLengthFeature.LongRunHighGrayLevelEmphasis = RunLengthFeature.LongRunHighGrayLevelEmphasis/4;

	return RunLengthFeature;
}
