ThreeDimensionClass GaborWaveletTexture::ThreeDimensionFunction(short ** MarkData,short ** TumorData,int SliceNumber,int nSliceHeight,int nSliceWidth)
{
	/*
	This C++ source code represents how to calculate the "Maximum diameter of tumor" feature.
	MarkData represents the tumor mask image by radiologist.
	TumorData represnets the tumor image.
	SliceNumber represents the number of tumor-containing image layers.
	nSliceHeight and nSliceWidth are same with Height and Width.
	Function "DllTraceDIB" is also presented in this folder.
	*/
	ThreeDimensionClass ThreeDimensionFeature = {0};
	short ** pTumorData = MarkData;
	short ** pOriData = TumorData;
	int TumorSliceNumber = SliceNumber;
	int Height = nSliceHeight;
	int Width = nSliceWidth;
	short ** pContourData = new short* [TumorSliceNumber];
	for(int i = 0;i < TumorSliceNumber;i++)
	{
		pContourData[i] = new short[Height*Width];
		memset(pContourData[i],0,sizeof(short)*Height*Width);
		memcpy(pContourData[i],pTumorData[i],sizeof(short)*Height*Width);
		DllTraceDIB(pContourData[i], nSliceWidth, nSliceHeight); 
	}
	double Max3DDiameter = 0.0;
	for(int i = 0;i < TumorSliceNumber;i++)
	{
		for(int j = 0;j < Height;j++)
		{
			for(int k = 0;k < Width;k++)
			{
				if(pContourData[i][j*Width+k] == 4096)
				{
					for(int i1 = 0;i1 < TumorSliceNumber;i1++)
					{
						for(int j1 = 0;j1 < Height;j1++)
						{
							for(int k1 = 0;k1 < Width;k1++)
							{
								if(pContourData[i1][j1*Width+k1] == 4096)
								{
									double Euclidean = (i-i1)*(i-i1)+(j-j1)*(j-j1)+(k-k1)*(k-k1);
									if (Euclidean > Max3DDiameter)
										Max3DDiameter = Euclidean;
								}

							}
						}
					}
				}
			}
		}
	}

	Feature.TDFeature.Maximum3Ddiameter = Max3DDiameter;
	return ThreeDimensionFeature;
}